/***************************************************************************
 *   Copyright (C) 2007 by Claudio Scafuri, Giacomo Strangolino   *
 *   claudio@hyo   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
// cumbia
#include <cumbiapool.h>
#include <cuthreadfactoryimpl.h>
#include <qthreadseventbridgefactory.h>
// cumbia

#include <quapplication.h>
#include "alarm.h"
#include <X11/Xlib.h>
#include <QX11Info>
#include <QDebug>


int main( int argc, char ** argv ) 
{
    char identifier[128];
    QString appname;
    appname = QString(argv[0]);
    if(argc > 1)
        appname += QString("-%1").arg(argv[1]);

    snprintf(identifier, 128, "%s", appname.toStdString().c_str());
    for(unsigned int i = 0; i < strlen(identifier); i++)
        if(identifier[i] == '/' || identifier[i] == '.')
            identifier[i] = '-';
    

    QuApplication qu_app( argc, argv );
    qu_app.setOrganizationName("Elettra");
    qu_app.setApplicationName("alarm-ng");
    qu_app.setProperty("author", "Giacomo");
    qu_app.setProperty("mail", "giacomo.strangolino@elettra.eu");
    qu_app.setProperty("phone", "0403758073");
    qu_app.setProperty("office", "T2PT025");
    qu_app.setProperty("hwReferent", "Graziano"); /* name of the referent that provides the device server */


    CumbiaPool *cu_p = new CumbiaPool();
    Alarm *w = new Alarm(cu_p, NULL);
    w->show();


    for(int j = 0; j < qApp->arguments().size(); j++)
    {
        if(qApp->arguments().at(j).contains(QRegExp("style\\s*=?\\s*booster")))
        {
            w->setWindowIcon(QIcon(":icons/booster-alarm.png"));
            break;
        }
        else if(qApp->arguments().at(j).contains(QRegExp("style\\s*=?\\s*elettra")))
        {
            w->setWindowIcon(QIcon(":icons/elettra-alarm.png"));
            break;
        }
        else if(qApp->arguments().at(j).contains(QRegExp("style\\s*=?\\s*fermi")))
        {
            w->setWindowIcon(QIcon(":icons/fermi-alarm.png"));
            break;
        }
        else
        {
            //qDebug()<< "style = elettra|booster|fermi on the command line if you want to personalize the style";
        }
    }


    w->setWindowTitle("Alarm [ng]");


    // exec application loop
    int ret = qu_app.exec();
    // delete resources and return
    delete w;

    for(std::string n : cu_p->names())
        if(cu_p->get(n))
            delete cu_p->get(n);
    return ret;
}

